/*
 * ---------------------------------------------------------------------
 * AEUtilities.h :
 *
 *  Copyright 1992 by F. Menneteau.  All rights reserved.
 * This code can be both distributed and used freely.
 *
 * ---------------------------------------------------------------------
 */


#pragma once

#include "AERegistry.h"


#define S(str)				(* (Str255 *) (str))

#define PSTRLASTCHAR(s)		(s)[*(s)]


#define RETN_IF_ERR(e)		if ( e != noErr ) return(e)
#define EXIT_IF_ERR(e)		if ( e != noErr ) ExitToShell()


#define kFinderSignature	'MACS'

#define PDELIMITER			((Ptr) "\p:")
#define PEMPTY				((Ptr) "\p")
#define COMMA				((Ptr) ",")
#define DELIMITER			((Ptr) ":")
#define PPCTOOLBOX			((Ptr) "\pPPCToolbox")
#define FINDER				((Ptr) "\pFinder")


typedef enum {
	typeFOLDER = 'fold',
	typeFILE = 'file'
} TypeEntity ;


typedef AEAddressDesc	*AEAddrDescPtr		;
typedef AppleEvent		*AppleEventPtr		;
typedef PPCSessRefNum	*PPCSessRefNumPtr	;


typedef enum {
	sNONE,
	sTARGET_ID,
	sSIGN_ONLY,
	sTYPE_AND_SIGN,
	sPSN,
	sSESSION_ID
} SelectorType ;


typedef struct {
	SelectorType			tSelector	;

	union {
		TargetID			tTargetID	;
		struct {
			OSType			tType		;
			OSType			tSignature	;
		} s ;
		ProcessSerialNumber	tPSNumber	;
		PPCSessRefNum		tSessionID	;
	} u ;
} TargetInfo, *TargetInfPtr, **TargetInfHandle ;



/*
 **************************************************************************
 */
OSErr GetTargetID(Str31, Str31, Str32, TargetIDPtr);
OSErr EntityPathToAlias(Ptr, TypeEntity, AliasHandle *);
OSErr GetProcessPSN(OSType, OSType, ProcessSerialNumberPtr);
OSErr KillProcess(Boolean, Boolean, OSType, OSType);

