/****
 * CADSPInPane.c
 *
 *	Methods for a pane which gets input from ADSP
 *
 *  Copyright  1990 Symantec Corporation.  All rights reserved.
 *
 ****/

#include "CADSPOutPane.h"
#include "CMessenger.h"

/***
 * IADSPOutPane
 *
 *		Setup the pane
 ***/
void CADSPOutPane::IADSPOutPane(
				CView			*anEnclosure,
				CBureaucrat		*aSupervisor,
				CMessenger		*aMessenger)
{
	CEditText::IEditText(anEnclosure, aSupervisor,
					 10, 10, 0, 0, sizELASTIC, sizELASTIC, -1);
					 
	itsMessenger = aMessenger;
}

/***
 * TypeChar
 *
 *		If the character is being typed, we want to send it too.
 ***/
void CADSPOutPane::TypeChar(char theChar, short theModifiers)
{
	EventRecord theEvent;

	inherited::TypeChar(theChar, theModifiers);
	theEvent.what = keyDown;
	theEvent.message = (short)theChar;
	theEvent.modifiers = theModifiers;
	itsMessenger->SendMessage(&theEvent, sizeof(EventRecord));
}
