/******************************************************************************
 CChoicesButton.h

		Interface for the ChoicesButton Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
	TCL 1.1 CHANGES
	[
		- added INewChoicesButton initialization method for to support creation
		  without a CNTL resource.
		- added IChoicesButtonX method to handle initialization common to
		  IChoicesButton and INewChoicesButton
		- added GetClickCmd, SetDefault methods
	]
	TCL 1.1.3 Changes
	[
		- use #pragma once
	]
 ******************************************************************************/

#pragma once

#include "CButton.h"					/* Interface for its superclass		*/

class CChoicesButton : public CButton {				/* Class Declaration				*/

protected:
	Boolean		dialogIsBig;		/* TRUE if button reads Fewer Choies */
	
	long		firstToHide,		/* First view to hide */
				lastToHide;			/* Last view to hide */
				
	long		firstToMoveUp,		/* First view to move up */
				lastToMoveUp;		/* Last view to move up */
				
	long		distanceToMove;		/* How far to move items up and down */	

public:
								/** Instance Methods **/
									/** Construction **/
	void		IChoicesButton(short CNTLid, CView *anEnclosure,
							CBureaucrat		*aSupervisor);
	void		INewChoicesButton( short aWidth, short aHeight, short aHEncl, short aVEncl, 
					StringPtr title, Boolean fVisible, short procID,
					CView *anEnclosure, CBureaucrat	*aSupervisor);
	void		IChoicesButtonX( void);
	virtual void		
				IViewTemp(CView *anEnclosure, CBureaucrat *aSupervisor,	Ptr viewData);
									/** Information and Control **/
	void		UpdateButtonText( void);
	
	Boolean		IsDialogBig( void);
	
	virtual void		SetViewsToHide (long first, long last);
	virtual void		SetViewsToMoveUp (long first, long last);
	
									/** Click Handling **/
	virtual void		DoFewerChoices( void);
	virtual void		DoMoreChoices( void);
	virtual void		DoGoodClick(short whichPart);

};

typedef struct	{						/* Pane template					*/
	PaneTemp		sPaneTemp;
	long			firstToHide,
					lastToHide,
					firstToMoveUp,
					lastToMoveUp;
} ChoicesButtonTemp, *ChoicesButtonTempP;

#define		cmdToggleChoicesButton			3000

#define		kChoicesButtonStrings			134