/*
 *	File:		CDividedPane.h
 *	Evironment:	MacOS 7.0/THINK C 5.0/TCL 1.1.1
 *	Author:		Mark Alldritt
 *
 *
 *		Copyright  1992  All Rights Reserved
 *		Mark Alldritt
 *		1571 Deep Cove Road
 *		N. Vancouver, B.C. CANADA
 *
 *	
 *	Edit History:
 *
 *	V01-01		Mark Alldritt	15-Jun-1992
 *	- Initial version of module.
 */

#define _H_CDividedPane

#include <CPane.h>

struct CDividedPane : CPane {

	/*	Instance variables	*/

	CPane		*its1stPane;
	CPane		*its2ndPane;
	Boolean		splitHorizontally;
	short		dividerPos;
	short		dividerSize;
	short		min1st;
	short		min2nd;
	short		itsStepSize;

	/*	Construction/destruction methods	*/

	void	IDividedPane(CView *anEnclosure, CBureaucrat *aSupervisor,
						 short aWidth, short aHeight,
						 short aHEncl, short aVEncl,
						 SizingOption aHSizing, SizingOption aVSizing,
						 Boolean splitHorizontally,
						 short dividerPos, short dividerSize,
						 short min1st, short min2nd);

	/*	Drawing methods	*/
	
	void	Draw(Rect *area);
	
	/*	Event methdos	*/
	
	void	DoClick(Point hitPt, short modifierKeys, long when);
	void	AdjustCursor(Point where, RgnHandle mouseRgn);

	/*	Accessing methods	*/

	short	GetDividerPos(void);
	CPane	*Get1stPane(void);
	CPane	*Get2ndPane(void);
};