/***********************************************************************************
	CExpanderLabel.h

	Copyright  1994 B-Ray Software. All rights reserved.
	Developed using Symantec C++ 7.0.2 and Symantec's TCL library.
	Portions of this code courtesy Symantec, Inc.

	This code may be freely distributed as long as this notice remains. This code
	may not be used in any commercial software without the consent of B-Ray Software.

	---

	Header file for CExpanderLabel class.

***********************************************************************************/
#pragma once


#include "CExpanderText.h"


class CExpanderLabel : public CExpanderText {

TCL_DECLARE_CLASS

private:
	long			itsCommand;		// command to issue when double-clicked

protected:
	Handle			itsText;

	virtual void	MakeEnvironment( void );
	virtual short	CalcFrameWidth( void );
	virtual void	DrawLabel( Rect *area );

public:
	CExpanderLabel();
	CExpanderLabel( CView *anEnclosure, CBureaucrat *aSupervisor,
					short aWidth = 0, short aHeight = 0, short aHLoc = 0, short aVLoc = 0,
					SizingOption aHSizing = sizFIXEDSTICKY, 
					SizingOption aVSizing = sizFIXEDSTICKY );
	virtual ~CExpanderLabel();

	virtual void	SetLabelTextRsrcID( short rsrcID );

	virtual void	SetDblClickCmd( long theCommand ) { itsCommand = theCommand; };
	virtual long	GetDblClickCmd( void ) { return itsCommand; };

	virtual void	Draw( Rect *area );

	/*
	 * Pane overrides
	 */
	virtual void	DoClick( Point hitPt, short modifierKeys, long when );

	virtual void	Activate( void );
	virtual void	Deactivate( void );

	/*
	 * Stream methods
	 */
	virtual void	PutTo( CStream &stream );
	virtual void	GetFrom( CStream &stream );
};
