/***********************************************************************************
	CExpanderText.h

	Copyright  1994 B-Ray Software. All rights reserved.
	Developed using Symantec C++ 7.0.2 and Symantec's TCL library.
	Portions of this code courtesy Symantec, Inc.

	This code may be freely distributed as long as this notice remains. This code
	may not be used in any commercial software without the consent of B-Ray Software.

	---

	Header file for CExpanderText.cp

***********************************************************************************/
#pragma once


#include "CExpanderPane.h"


class CExpanderText : public CExpanderPane {

protected:
	short			lineHeight, ascent;

	virtual void	CalcLineHeight( void );
	virtual short	CalcFrameHeight( void );
	virtual short	CalcFrameWidth( void );
	virtual void	TextSizeChanged( void );

public:
	TCL_DECLARE_CLASS

	CExpanderText();
	CExpanderText( CView *anEnclosure, CBureaucrat *aSupervisor,
					short aWidth = 0, short aHeight = 0, short aHLoc = 0, short aVLoc = 0,
					SizingOption aHSizing = sizFIXEDSTICKY, 
					SizingOption aVSizing = sizFIXEDSTICKY );
	virtual ~CExpanderText();

	virtual void	ParentMessage( long message, void *param );

	virtual void	PutTo( CStream &stream );
	virtual void	GetFrom( CStream &stream );
};

