/*

  readme.c
 
 	General information about this library/project.
 
  October 8, 1992  isl
  
  This code may be used, modified, and distributed free of charge and obligation
  as long as the Symantec Copyright is honored.
  
*/

/* =====================* /
/ *===---------------===* /

Notes:


The File project is meant to augment the file classes supplied with TCL 1.1
with the standard CFile as the superclass.

It provides the following facilities in addition to standard:

1.	Custom icons for files and folders;
2.	Folder creation and access;
3.	Access to a file's path (limited to 255 characters, sorry);
4.	Improved methods for resource files;
5.	More general file information retrieval and manipulation;
6.	Specifying a file by creator and type;
7.	Emulation of the FSMakeFSSpec trap for System 6;
8.	Moving files to the Trash as an alternative to permanent erasure;
9.	Creation of files with unique names, and
10.	A local Gestalt flag, and
11.	Stationery awareness.


You will find that my resource file class is mostly the standard CResFile while
the data file class is exactly the original CDataFile.

The header file supplied with this project is the generic file I use for all my projects.
You may find that a slimmer file will do just fine.
IsleHeaders.h is meant to be precompiled for faster builds.

/ *===-------------===* /

Class list:

1. CIsleFile (subclass of CFile)
	Implements the driver level general routines
	
2. CIsleDataFile (subclass of CIsleFile)
	Identical to the standard CDataFile but subclasses off of CIsleFile
	
3. CFolder (subclass of CIsleFile)
	Implements folder specific routines
	
4. CIsleResFile (subclass of CIsleFile)
	A slight variation of the standard CResFile
	
5. CCustomIcon (subclass of CIsleResFile)
	Implements custom icons for folders or files


/ *===---------------===* /

Build instructions:

These classes were designed to run under full TCL 1.1.  However, they will work
with a bare-bones framework as well.  These classes rely little on other
TCL classes.

An demo application using these classes will be posted to TCL-Talk in the first half
of October,

To build a project with File classes you will need:

1. Classes.
	The File classes rely on some methods defined in the superclasses CFile and CObject.
	They also access some global variables common to TCL.
	Make sure to include the oop libraries and the MacTraps libraries as these
	classes use toolbox calls and oop specific calls.
	
2. Custom headers.
	This distribution should contain a file called IsleHeaders.h.  This file may be
	precompiled for faster builds.  File classes make no direct reference to this file as it is 
	included automatically (Options:Prefix).
	Cosmetics.h is referenced by this file and is also included with this distribution.
	IconFamilies.h provides icon suite definitions for CCustomIcon.
	
3. Resources.
	Make sure to include the 'STR#', 'Estr', and the 'TMPL' resources
	from this distribution in your project resource file.  These are error strings.


/ *===---------------===* /

Author:

	Igor Livshits						e: igorl@ncsa.uiuc.edu
	NCSA - 240 Computer Applications Building
	University of Illinois
	605 East Springfield Avenue, Champaign, Illinois 61820 
	(217) 244-5606
	Champaign-Urbana campus
		
	To steal some words from Jamie:
		* I'm releasing this code with the hope that someone will get something
 		* out of it.  Feedback of any sort, even just letting me know that you're
		* using it, is greatly appreciated!
		
	Thanks, Igor


/ *===---------------===* /

TCL-Talk:

List- 										TCL-TALK@BROWNVM.brown.edu
Requests/Administration-	LISTSERV@BROWNVM.brown.edu
Anonymous FTP-						ftp.brown.edu (/pub/tcl)

/ *===---------------===* /
/ *=====================*/