/******************************************************************************
 CPixelWorldPane.h

					Interface for the PixelWorldPane Class
	
	The CPixelWorldPane class is a subclass of CPanorama that uses a 
	CPixelWorld object to display a color or grayscale image that is 
	kept offscreen.  An offscreen color graphics device (GDevice) and an 
	offscreen color graphics port (CGrafPort) are used to maintain this 
	offscreen world.  This implementation supports 1,2,4 and 8 bit pixel 
	depths.  Pixel depths of 16 and 32 bits are not currently supported.  
	
	This implementation does not depend upon any 32-Bit QuickDraw features.  
	Future versions of the CPixelWorld class will provide support for pixel 
	depths of 16 and 32 bits, and for GWorlds under 32-Bit QuickDraw.  
	
	SUPERCLASS = CPanorama
	
	This implementation is based in part on material copyrighted by 
	Symantec Corporation and Apple Computer, Inc.  
	
	Copyright  1992 Vincent R. Vann, Jr.  All rights reserved.  
	
	Version 1.2 Changes:
	[
		- changed class definition to make the superclass CPanorama 
		  instead of CBitMapPane as in the original implementation.  
		- modified the SetPixelWorld method so that the bounds, position, 
		  and origin of the PixelWorldPane are changed to reflect the 
		  new PixelWorld's coordinates.  This method also refreshes the 
		  pane so that the image of the new PixelWorld will be drawn.  
	]
	
 ******************************************************************************/
 
#define _H_CPixelWorldPane

#include "CPanorama.h"					/* Interface for its superclass */
#include "CPixelWorld.h"

class CPixelWorldPane : public CPanorama	/* Class Declaration		*/
{
public:
								/** Instance Variables **/
								
	CPixelWorld		*itsPixelWorld;

								/** Instance Methods **/

									/** Contruction **/
	void	IPixelWorldPane( CView *anEnclosure, CBureaucrat *aSupervisor,
							short aWidth, short aHeight,
							short aHEncl, short aVEncl,
							SizingOption aHSizing, SizingOption aVSizing,
							LongRect *aBounds, CPixelWorld *aPixelWorld);
	void	IPixelWorldPaneX( void);
	
									/** Destruction **/
	virtual void		 Dispose( void);
	
									/** Accessing **/
	virtual CPixelWorld* GetPixelWorld( void);
	virtual void		 SetPixelWorld( CPixelWorld *aPixelWorld);
	
									/** Drawing **/
	virtual void		 Draw( Rect *area);
};

